/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     AND = 258,
     AS = 259,
     CONST = 260,
     DEF = 261,
     DIV = 262,
     ELSE = 263,
     EXTERN = 264,
     IF = 265,
     IMPORT = 266,
     IN = 267,
     INCLUDE = 268,
     MOD = 269,
     NOT = 270,
     OR = 271,
     OTHERWISE = 272,
     PRIVATE = 273,
     PUBLIC = 274,
     SPECIAL = 275,
     THEN = 276,
     TYPE = 277,
     UNDEF = 278,
     VAR = 279,
     WHERE = 280,
     DOTDOT = 281,
     CAT = 282,
     DBAR = 283,
     LEQ = 284,
     GEQ = 285,
     NEQ = 286,
     STR = 287,
     UID = 288,
     LID = 289,
     QUID = 290,
     QLID = 291,
     STR1 = 292,
     INT = 293,
     FLOAT = 294,
     ERRTOK = 295,
     EOFTOK = 296
   };
#endif
#define AND 258
#define AS 259
#define CONST 260
#define DEF 261
#define DIV 262
#define ELSE 263
#define EXTERN 264
#define IF 265
#define IMPORT 266
#define IN 267
#define INCLUDE 268
#define MOD 269
#define NOT 270
#define OR 271
#define OTHERWISE 272
#define PRIVATE 273
#define PUBLIC 274
#define SPECIAL 275
#define THEN 276
#define TYPE 277
#define UNDEF 278
#define VAR 279
#define WHERE 280
#define DOTDOT 281
#define CAT 282
#define DBAR 283
#define LEQ 284
#define GEQ 285
#define NEQ 286
#define STR 287
#define UID 288
#define LID 289
#define QUID 290
#define QLID 291
#define STR1 292
#define INT 293
#define FLOAT 294
#define ERRTOK 295
#define EOFTOK 296




/* Copy the first part of user declarations.  */
#line 2 "qc.y"


/* qc.y: yacc source of Q parser and Q compiler main program */

/* Special case constructs (unary minus, 1-tuples) cause a number of parsing
   conflicts which are resolved correctly. */

/*  Q eQuational Programming System
    Copyright (c) 1991-2002 by Albert Graef
    <ag@muwiinfa.geschichte.uni-mainz.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "qcdefs.h"

int      	nerrs, nwarns;
bool		hflag, nflag, vflag, Vflag, wflag;
volatile bool   int_sig;
char           *self = "qc", *list = "";

char		signon[] = QC_SIGNON;
char   		usage[] = QC_USAGE;
char		opts[MAXSTRLEN];
char		copying[] = COPYING;
char		helpmsg[] = HELPMSG;

DECLARE_YYTEXT

static int type, fno_min, fno_max;
static byte flags, sflags;
static unsigned long argv;

static void start_qualifiers(void), qualifiers(void);
static void add_qualifier(EXPR *x);
static void start_where_clauses(void), end_where_clauses(void),
  add_where_clause(EXPR *l, EXPR *r);

static xvect_t *exprlist(void);
static xvect_t *addexpr(xvect_t *v, EXPR *x);
static EXPR *tupleexpr(xvect_t *v);
static EXPR *listexpr(xvect_t *v);


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 59 "qc.y"
typedef union YYSTYPE {
  int ival;
  mpz_t zval;
  double fval;
  char *sval;
  EXPR *xval;
  xvect_t *xvval;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 223 "qc.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 235 "qc.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   777

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  65
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  81
/* YYNRULES -- Number of rules. */
#define YYNRULES  231
/* YYNRULES -- Number of states. */
#define YYNSTATES  341

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   296

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    57,     2,    55,     2,     2,     2,    59,
      61,    62,    53,    45,    43,    46,    58,    54,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    47,    42,
      51,    48,    52,     2,    44,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    63,     2,    64,    56,     2,    60,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    49,     2,    50,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     7,     8,    12,    16,    19,    22,
      25,    28,    31,    35,    38,    42,    44,    48,    51,    55,
      57,    61,    64,    68,    72,    73,    78,    83,    89,    90,
      97,    98,   106,   107,   114,   115,   123,   124,   127,   128,
     131,   132,   135,   137,   141,   142,   146,   148,   150,   153,
     154,   156,   158,   160,   162,   165,   167,   169,   171,   173,
     175,   176,   181,   184,   188,   189,   192,   196,   197,   200,
     204,   208,   210,   214,   215,   220,   222,   226,   228,   229,
     234,   235,   240,   241,   248,   249,   252,   255,   258,   260,
     261,   265,   267,   271,   275,   277,   281,   283,   287,   289,
     291,   293,   295,   297,   299,   301,   305,   307,   311,   313,
     315,   317,   319,   321,   323,   325,   327,   331,   335,   337,
     339,   341,   344,   346,   350,   352,   354,   356,   358,   360,
     363,   365,   368,   371,   374,   377,   379,   381,   383,   387,
     389,   391,   393,   397,   399,   402,   404,   406,   408,   410,
     412,   414,   418,   420,   422,   424,   428,   431,   436,   441,
     446,   451,   456,   461,   466,   471,   476,   481,   486,   491,
     496,   499,   503,   507,   513,   519,   527,   530,   534,   540,
     546,   548,   552,   554,   556,   558,   560,   562,   564,   566,
     568,   570,   572,   574,   576,   579,   581,   583,   585,   587,
     589,   592,   594,   596,   598,   600,   602,   604,   606,   608,
     610,   612,   614,   616,   618,   620,   622,   624,   626,   628,
     630,   632,   634,   636,   638,   640,   642,   644,   646,   648,
     650,   652
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
      66,     0,    -1,    -1,    67,    68,    -1,    -1,    68,    69,
      42,    -1,    68,    71,    42,    -1,    68,    73,    -1,    68,
      74,    -1,    68,    96,    -1,    68,   102,    -1,    68,    41,
      -1,    68,     1,    42,    -1,    11,    70,    -1,    69,    43,
      70,    -1,    37,    -1,    37,     4,    37,    -1,    13,    72,
      -1,    71,    43,    72,    -1,    37,    -1,    37,     4,    37,
      -1,    44,    38,    -1,    44,    45,    38,    -1,    44,    46,
      38,    -1,    -1,    86,    75,    91,    42,    -1,    22,   145,
      80,    42,    -1,    88,    22,   145,    80,    42,    -1,    -1,
      22,   144,    81,    76,    82,    42,    -1,    -1,    88,    22,
     144,    81,    77,    82,    42,    -1,    -1,     9,    22,   144,
      81,    78,    42,    -1,    -1,    88,     9,    22,   144,    81,
      79,    42,    -1,    -1,     4,   144,    -1,    -1,    47,   143,
      -1,    -1,    48,    83,    -1,    84,    -1,    83,    49,    84,
      -1,    -1,    85,    87,    91,    -1,    88,    -1,    89,    -1,
      88,    89,    -1,    -1,    86,    -1,    18,    -1,    19,    -1,
      90,    -1,    89,    90,    -1,     5,    -1,    20,    -1,     9,
      -1,    24,    -1,    93,    -1,    -1,    91,    43,    92,    93,
      -1,   134,    94,    -1,   135,    94,    95,    -1,    -1,    94,
      33,    -1,    94,    50,    33,    -1,    -1,     4,   134,    -1,
       6,    97,    42,    -1,    23,   100,    42,    -1,    98,    -1,
      97,    43,    98,    -1,    -1,    99,   113,    48,   113,    -1,
     101,    -1,   100,    43,   101,    -1,   133,    -1,    -1,   113,
     103,    48,   104,    -1,    -1,   105,   113,   107,    42,    -1,
      -1,   104,    48,   106,   113,   107,    42,    -1,    -1,   107,
     108,    -1,   107,   109,    -1,    10,   116,    -1,    17,    -1,
      -1,    25,   110,   111,    -1,   112,    -1,   111,    43,   112,
      -1,   113,    48,   113,    -1,   114,    -1,   113,    28,   114,
      -1,   119,    -1,   119,   115,   119,    -1,    51,    -1,    52,
      -1,    29,    -1,    30,    -1,    31,    -1,    12,    -1,   117,
      -1,   116,    28,   117,    -1,   119,    -1,   119,   118,   119,
      -1,    51,    -1,    52,    -1,    48,    -1,    29,    -1,    30,
      -1,    31,    -1,    12,    -1,   121,    -1,   119,   120,   121,
      -1,   119,    46,   121,    -1,    45,    -1,    27,    -1,    16,
      -1,    16,     8,    -1,   123,    -1,   121,   122,   123,    -1,
      53,    -1,    54,    -1,     7,    -1,    14,    -1,     3,    -1,
       3,    21,    -1,   125,    -1,    46,    38,    -1,    46,    39,
      -1,    46,   123,    -1,   124,   123,    -1,    55,    -1,    15,
      -1,   127,    -1,   127,   126,   125,    -1,    56,    -1,    57,
      -1,   128,    -1,   127,    58,   128,    -1,   130,    -1,   128,
     130,    -1,    59,    -1,    60,    -1,    50,    -1,    38,    -1,
      39,    -1,    32,    -1,    61,   132,    62,    -1,   136,    -1,
     142,    -1,   139,    -1,   139,    47,   143,    -1,   129,   130,
      -1,    61,   116,    28,    62,    -1,    61,    28,   117,    62,
      -1,    61,   119,   118,    62,    -1,    61,   118,   119,    62,
      -1,    61,   119,   120,    62,    -1,    61,   119,    46,    62,
      -1,    61,   120,   121,    62,    -1,    61,   121,   122,    62,
      -1,    61,   122,   123,    62,    -1,    61,   127,   126,    62,
      -1,    61,   126,   125,    62,    -1,    61,   127,    58,    62,
      -1,    61,    58,   128,    62,    -1,    61,    62,    -1,    61,
     130,    62,    -1,    61,   116,    62,    -1,    61,   116,    49,
     116,    62,    -1,    61,   116,    43,   131,    62,    -1,    61,
     116,    43,   131,    49,   116,    62,    -1,    63,    64,    -1,
      63,   131,    64,    -1,    63,   131,    49,   116,    64,    -1,
      63,   131,    26,   116,    64,    -1,   116,    -1,   131,    43,
     116,    -1,    28,    -1,    51,    -1,    52,    -1,    48,    -1,
      29,    -1,    30,    -1,    31,    -1,    12,    -1,    27,    -1,
      45,    -1,    46,    -1,    16,    -1,    16,     8,    -1,    53,
      -1,    54,    -1,     7,    -1,    14,    -1,     3,    -1,     3,
      21,    -1,    55,    -1,    15,    -1,    59,    -1,    60,    -1,
      50,    -1,    56,    -1,    57,    -1,    58,    -1,   136,    -1,
     140,    -1,   137,    -1,   141,    -1,   138,    -1,   142,    -1,
      34,    -1,    36,    -1,    34,    -1,    36,    -1,    33,    -1,
      33,    -1,    35,    -1,    33,    -1,    35,    -1,    33,    -1,
      34,    -1,    35,    -1,    36,    -1,    33,    -1,    34,    -1,
      35,    -1,    36,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   101,   101,   101,   105,   106,   108,   110,   112,   114,
     116,   118,   125,   129,   130,   133,   135,   139,   140,   143,
     145,   149,   151,   153,   159,   158,   161,   167,   174,   173,
     191,   190,   207,   206,   211,   210,   217,   218,   223,   224,
     228,   229,   232,   233,   236,   236,   240,   241,   242,   245,
     246,   249,   251,   255,   256,   259,   261,   263,   265,   269,
     270,   270,   273,   288,   310,   311,   320,   329,   330,   334,
     335,   338,   339,   342,   342,   347,   348,   351,   364,   363,
     368,   368,   372,   371,   377,   378,   380,   383,   385,   390,
     389,   395,   396,   399,   403,   404,   408,   409,   413,   414,
     415,   416,   417,   418,   421,   422,   426,   427,   431,   432,
     433,   434,   435,   436,   437,   440,   441,   443,   447,   448,
     449,   450,   453,   454,   458,   459,   460,   461,   462,   463,
     468,   469,   470,   471,   472,   475,   476,   479,   480,   484,
     485,   488,   489,   493,   494,   498,   499,   500,   506,   507,
     508,   512,   513,   514,   515,   517,   523,   528,   531,   536,
     539,   544,   547,   550,   555,   558,   563,   566,   571,   574,
     581,   583,   585,   587,   589,   592,   598,   600,   603,   605,
     611,   613,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   646,
     647,   650,   651,   654,   655,   658,   660,   664,   668,   672,
     676,   678,   682,   686,   690,   692,   694,   696,   700,   702,
     706,   708
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "AND", "AS", "CONST", "DEF", "DIV", "ELSE", 
  "EXTERN", "IF", "IMPORT", "IN", "INCLUDE", "MOD", "NOT", "OR", 
  "OTHERWISE", "PRIVATE", "PUBLIC", "SPECIAL", "THEN", "TYPE", "UNDEF", 
  "VAR", "WHERE", "DOTDOT", "CAT", "DBAR", "LEQ", "GEQ", "NEQ", "STR", 
  "UID", "LID", "QUID", "QLID", "STR1", "INT", "FLOAT", "ERRTOK", 
  "EOFTOK", "';'", "','", "'@'", "'+'", "'-'", "':'", "'='", "'|'", "'~'", 
  "'<'", "'>'", "'*'", "'/'", "'#'", "'^'", "'!'", "'.'", "'''", "'`'", 
  "'('", "')'", "'['", "']'", "$accept", "source", "@1", "program", 
  "imports", "import", "includes", "include", "priority", "declaration", 
  "@2", "@3", "@4", "@5", "@6", "type_alias", "opt_type", 
  "opt_header_sects", "header_sects", "header_sect", "@7", "prefix", 
  "opt_prefix", "scope", "modifiers", "modifier", "headers", "@8", 
  "header", "vid_list", "id_alias", "definition", "defs", "def", "@9", 
  "undefs", "undef", "rule", "@10", "body", "@11", "@12", "qualifiers", 
  "condition", "where", "@13", "where_clauses", "where_clause", 
  "lexpression", "lrelation", "lrelop", "expression", "relation", "relop", 
  "addition", "addop", "multiplication", "mulop", "unary", "unop", 
  "script", "scriptop", "composition", "application", "quoteop", 
  "primary", "expr_list", "op", "id", "nid", "qid", "fid", "nfid", "qfid", 
  "vid", "fvid", "nfvid", "qfvid", "tid", "ntid", "qtid", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,    59,    44,    64,    43,    45,    58,    61,   124,
     126,    60,    62,    42,    47,    35,    94,    33,    46,    39,
      96,    40,    41,    91,    93
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    65,    67,    66,    68,    68,    68,    68,    68,    68,
      68,    68,    68,    69,    69,    70,    70,    71,    71,    72,
      72,    73,    73,    73,    75,    74,    74,    74,    76,    74,
      77,    74,    78,    74,    79,    74,    80,    80,    81,    81,
      82,    82,    83,    83,    85,    84,    86,    86,    86,    87,
      87,    88,    88,    89,    89,    90,    90,    90,    90,    91,
      92,    91,    93,    93,    94,    94,    94,    95,    95,    96,
      96,    97,    97,    99,    98,   100,   100,   101,   103,   102,
     105,   104,   106,   104,   107,   107,   107,   108,   108,   110,
     109,   111,   111,   112,   113,   113,   114,   114,   115,   115,
     115,   115,   115,   115,   116,   116,   117,   117,   118,   118,
     118,   118,   118,   118,   118,   119,   119,   119,   120,   120,
     120,   120,   121,   121,   122,   122,   122,   122,   122,   122,
     123,   123,   123,   123,   123,   124,   124,   125,   125,   126,
     126,   127,   127,   128,   128,   129,   129,   129,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     130,   130,   130,   130,   130,   130,   130,   130,   130,   130,
     131,   131,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   133,
     133,   134,   134,   135,   135,   136,   136,   137,   138,   139,
     140,   140,   141,   142,   143,   143,   143,   143,   144,   144,
     145,   145
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     0,     3,     3,     2,     2,     2,
       2,     2,     3,     2,     3,     1,     3,     2,     3,     1,
       3,     2,     3,     3,     0,     4,     4,     5,     0,     6,
       0,     7,     0,     6,     0,     7,     0,     2,     0,     2,
       0,     2,     1,     3,     0,     3,     1,     1,     2,     0,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       0,     4,     2,     3,     0,     2,     3,     0,     2,     3,
       3,     1,     3,     0,     4,     1,     3,     1,     0,     4,
       0,     4,     0,     6,     0,     2,     2,     2,     1,     0,
       3,     1,     3,     3,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     3,     1,     1,
       1,     2,     1,     3,     1,     1,     1,     1,     1,     2,
       1,     2,     2,     2,     2,     1,     1,     1,     3,     1,
       1,     1,     3,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     1,     1,     1,     3,     2,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       2,     3,     3,     5,     5,     7,     2,     3,     5,     5,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     4,     1,     0,     0,    55,    73,    57,     0,
       0,   136,    51,    52,    56,     0,     0,    58,   150,   219,
     215,   223,   216,   148,   149,    11,     0,     0,   147,   135,
     145,   146,     0,     0,     0,     0,     7,     8,    24,    46,
      47,    53,     9,    10,    78,    94,    96,   115,   122,     0,
     130,   137,   141,     0,   143,   152,   154,   153,    12,     0,
      71,     0,     0,    15,    13,    19,    17,   228,   229,   230,
     231,    38,    36,   220,   221,     0,    75,    77,   209,   210,
      21,     0,     0,   131,   132,   133,   128,   126,   114,   127,
     136,   120,   119,   182,   111,   112,   113,   118,   192,   110,
     147,   108,   109,   124,   125,   135,   139,   140,   208,   145,
     146,   170,     0,   104,     0,   106,     0,   115,     0,     0,
     137,   143,     0,   176,   180,   106,     0,     5,     0,     6,
       0,     0,    57,     0,    48,    57,    54,     0,     0,   103,
     120,   119,   100,   101,   102,   118,     0,    98,    99,     0,
       0,   128,   126,   127,   124,   125,     0,   134,   139,   140,
       0,     0,   144,   156,     0,    69,    73,     0,    38,     0,
       0,     0,    28,     0,     0,    70,     0,    22,    23,   129,
     121,     0,     0,     0,     0,     0,   172,     0,   114,   111,
     112,   113,     0,   110,   108,   109,     0,     0,     0,     0,
       0,     0,     0,     0,   171,   151,     0,     0,     0,     0,
       0,   177,    14,    18,   222,   217,   218,     0,    59,    64,
      64,   211,   213,   212,   214,     0,    38,    36,    95,    80,
     121,   117,    97,   116,   129,   123,   142,   138,   224,   225,
     226,   227,   155,    72,     0,    32,    16,    20,    39,    40,
      37,    26,    76,   158,   169,   157,   105,     0,     0,   160,
     162,   159,   107,   161,   163,   164,   165,   167,   168,   166,
       0,   181,     0,    25,    60,    62,    67,    38,    30,     0,
      79,     0,    74,     0,    44,     0,     0,   174,   173,   179,
     178,     0,    65,     0,     0,    63,    34,    40,    27,    82,
      84,    33,    41,    42,    49,    29,     0,    61,    66,    68,
       0,     0,     0,     0,    44,    50,     0,    46,   175,    35,
      31,    84,     0,    88,    89,    81,    85,    86,    43,    45,
       0,    87,     0,    83,    90,    91,     0,     0,     0,    92,
      93
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     2,     4,    34,    64,    35,    66,    36,    37,
     131,   249,   297,   283,   310,   174,   172,   285,   302,   303,
     304,    38,   316,    39,    40,    41,   217,   291,   218,   275,
     295,    42,    59,    60,    61,    75,    76,    43,   138,   280,
     281,   312,   313,   326,   327,   332,   334,   335,   336,    45,
     149,   124,   113,   114,   125,   150,    47,   156,    48,    49,
      50,   119,    51,    52,    53,    54,   126,   122,    77,   219,
     220,    55,   221,   222,    56,    79,   223,    57,   242,    71,
      72
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -159
static const short yypact[] =
{
    -159,    33,  -159,  -159,   211,    -7,  -159,  -159,    16,     3,
      18,  -159,  -159,  -159,  -159,   160,   171,  -159,  -159,  -159,
    -159,  -159,  -159,  -159,  -159,  -159,    96,   484,  -159,  -159,
    -159,  -159,   291,   323,     4,    74,  -159,  -159,  -159,   106,
     177,  -159,  -159,  -159,    21,  -159,   589,    29,  -159,   516,
    -159,   101,   714,   714,  -159,  -159,    24,  -159,  -159,    93,
    -159,   516,   150,    40,  -159,    81,  -159,  -159,  -159,  -159,
    -159,    48,    83,  -159,  -159,    97,  -159,  -159,  -159,  -159,
    -159,    55,    59,   610,   642,  -159,     8,    70,    82,   110,
     123,    10,   127,   516,   129,   138,   140,   147,   484,   148,
     151,   152,   153,   156,   157,   159,   161,   163,   714,   166,
     170,  -159,     2,  -159,   516,   551,   516,    29,   516,   714,
     105,   180,   186,  -159,   139,   577,    11,  -159,     3,  -159,
      18,   203,   205,   160,   177,  -159,  -159,   516,   206,  -159,
     143,  -159,  -159,  -159,  -159,  -159,   516,  -159,  -159,   516,
     516,   230,  -159,  -159,  -159,  -159,   516,  -159,  -159,  -159,
     714,   714,  -159,  -159,   229,  -159,  -159,    31,    48,   216,
     221,   229,  -159,   150,   217,  -159,   171,  -159,  -159,   198,
     207,   213,   251,   114,   516,   516,  -159,     7,  -159,  -159,
    -159,  -159,   356,  -159,  -159,  -159,   388,   420,    12,   452,
     214,   218,   674,   682,  -159,  -159,   516,   516,   516,   516,
     516,  -159,  -159,  -159,  -159,  -159,  -159,   145,  -159,  -159,
    -159,  -159,  -159,  -159,  -159,   150,    48,    83,  -159,  -159,
    -159,    29,    46,    29,  -159,  -159,   714,  -159,  -159,  -159,
    -159,  -159,  -159,  -159,   516,  -159,  -159,  -159,  -159,   219,
    -159,  -159,  -159,  -159,  -159,  -159,  -159,    94,    -1,  -159,
    -159,  -159,    46,  -159,  -159,  -159,  -159,  -159,  -159,  -159,
      13,   139,    20,  -159,  -159,   -11,    17,    48,  -159,   226,
     225,   516,    21,   237,  -159,   240,   516,  -159,  -159,  -159,
    -159,   203,  -159,   255,   165,  -159,  -159,   219,  -159,  -159,
      21,  -159,   242,  -159,   103,  -159,    14,  -159,  -159,  -159,
     253,   254,   516,    71,  -159,  -159,   203,   177,  -159,  -159,
    -159,    21,   516,  -159,  -159,  -159,  -159,  -159,  -159,   250,
      89,   139,   516,  -159,   256,  -159,    61,   516,   516,  -159,
      21
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -159,  -159,  -159,  -159,  -159,   169,  -159,   172,  -159,  -159,
    -159,  -159,  -159,  -159,  -159,    73,  -158,    19,  -159,   -10,
    -159,    27,  -159,    28,   -36,   -27,     1,  -159,    49,    95,
    -159,  -159,  -159,   194,  -159,  -159,   187,  -159,  -159,  -159,
    -159,  -159,    43,  -159,  -159,  -159,  -159,    30,    -3,   228,
    -159,   -30,   -81,   -21,    -4,   -12,   -26,   -16,   -18,  -159,
    -105,   -34,   334,   -97,  -159,   -28,   184,  -159,  -159,    76,
    -159,    -8,  -159,  -159,  -159,  -159,  -159,  -126,   201,   -55,
     241
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -208
static const short yytable[] =
{
      46,    44,   112,   134,   121,   224,   117,   168,    78,    85,
     245,   182,   181,   136,   201,   151,   118,   161,   180,   152,
     116,   294,   292,   140,   162,   163,   153,   206,   115,   179,
     183,   157,   151,     3,   141,    58,   152,   208,    62,   293,
      63,   206,   206,   153,   169,   184,   127,   128,   206,   137,
     292,   185,   145,   146,   209,    65,   237,    46,   167,   137,
     210,   288,   140,   236,   186,   154,   155,   293,   278,   259,
    -199,   164,  -193,   141,   264,   211,   318,   289,   226,   244,
      85,   322,   154,   155,   290,   170,   203,   173,   323,   137,
     198,   145,   146,   177,   196,   171,   324,   178,   237,   322,
     200,   199,   256,   197,   207,   236,   323,   136,     6,   338,
     187,     6,   135,   325,   324,   132,   129,   130,   250,   296,
     231,    12,    13,    14,   233,   256,    14,    17,   133,    11,
      17,   333,  -197,    46,    80,   165,   166,   209,   235,   175,
     176,    81,    82,   286,  -189,   232,    18,    19,    20,    21,
      22,   230,    23,    24,   162,   258,   287,   158,   159,   160,
      27,   158,   159,   202,    28,   224,   231,   206,    78,    29,
     277,   233,  -198,    30,    31,    32,   255,    33,   270,   271,
     272,   235,     6,    67,    68,  -202,   135,   273,   274,  -190,
     224,  -186,   262,    67,    68,    69,    70,    14,   214,   215,
    -187,    17,  -188,   262,    73,    20,    74,    22,   162,  -191,
    -185,    -3,     5,  -205,  -183,  -184,     6,     7,  -195,  -196,
       8,  -201,     9,  -206,    10,  -207,    11,   225,  -203,    12,
      13,    14,  -204,    15,    16,    17,   214,   215,    21,   216,
      46,   282,   204,    18,    19,    20,    21,    22,   205,    23,
      24,   234,    25,   246,   229,    26,   306,    27,   247,   251,
    -200,    28,   238,   239,   240,   241,    29,   284,   298,  -194,
      30,    31,    32,   299,    33,   253,   266,    46,   300,   301,
     267,   134,   305,    18,    19,    20,    21,    22,   308,    23,
      24,   314,   331,   274,    86,   319,   320,   212,    87,   337,
     279,    28,   213,    88,   328,    89,    90,    91,    46,   321,
      30,    31,    32,   254,    33,   276,   311,   329,    92,    93,
      94,    95,    96,    18,    19,    20,    21,    22,    46,    23,
      24,   315,   317,    46,    46,   340,    97,    98,    11,    99,
     307,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,    32,   111,    33,    18,    19,    20,    21,    22,
     243,    23,    24,   252,   330,   228,   120,   339,   257,    27,
     309,    11,   248,    28,   227,     0,     0,     0,    29,     0,
       0,     0,    30,    31,    32,     0,    33,   123,    18,    19,
      20,    21,    22,     0,    23,    24,     0,     0,     0,     0,
       0,     0,    27,    11,     0,     0,    28,     0,     0,     0,
       0,    29,     0,     0,     0,    30,    31,    32,   260,    33,
      18,    19,    20,    21,    22,     0,    23,    24,     0,     0,
       0,     0,     0,     0,    27,    11,     0,     0,    28,     0,
       0,     0,     0,    29,     0,     0,     0,    30,    31,    32,
     261,    33,    18,    19,    20,    21,    22,     0,    23,    24,
       0,     0,     0,     0,     0,     0,    27,    11,     0,     0,
      28,     0,     0,     0,     0,    29,     0,     0,     0,    30,
      31,    32,   263,    33,    18,    19,    20,    21,    22,     0,
      23,    24,     0,     0,     0,     0,     0,     0,    27,    11,
       0,     0,    28,     0,     0,     0,     0,    29,     0,     0,
       0,    30,    31,    32,   265,    33,    18,    19,    20,    21,
      22,     0,    83,    84,     0,     0,     0,     0,     0,     0,
      27,    11,     0,     0,    28,     0,     0,     0,     0,    29,
       0,     0,     0,    30,    31,    32,     0,    33,    18,    19,
      20,    21,    22,     0,    23,    24,     0,     0,     0,     0,
       0,     0,    27,   188,     0,     0,    28,   140,     0,     0,
       0,    29,     0,     0,     0,    30,    31,    32,   141,    33,
     189,   190,   191,     0,     0,     0,     0,     0,     0,   188,
       0,     0,     0,   140,     0,     0,   145,   192,     0,   193,
       0,   139,   194,   195,   141,   140,   189,   190,   191,     0,
       0,     0,     0,     0,     0,     0,   141,     0,   142,   143,
     144,     0,   145,   146,     0,   193,     0,     0,   194,   195,
       0,     0,     0,     0,   145,   146,     0,     0,     0,     0,
     147,   148,  -148,  -148,  -148,  -148,  -148,     0,  -148,  -148,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    -148,     0,     0,     0,     0,     0,  -148,  -148,  -148,  -148,
    -148,  -148,     0,  -148,  -149,  -149,  -149,  -149,  -149,     0,
    -149,  -149,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  -149,     0,     0,     0,     0,     0,  -149,  -149,
    -149,  -149,  -149,  -149,     0,  -149,    18,    19,    20,    21,
      22,     0,    23,    24,    18,    19,    20,    21,    22,     0,
      23,    24,     0,     0,    28,     0,     0,     0,     0,     0,
       0,     0,    28,    30,    31,    32,   268,    33,     0,     0,
       0,    30,    31,    32,   269,    33,    18,    19,    20,    21,
      22,     0,    23,    24,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    28,     0,     0,     0,     0,     0,
       0,     0,     0,    30,    31,    32,     0,    33
};

static const short yycheck[] =
{
       4,     4,    32,    39,    32,   131,    32,    62,    16,    27,
     168,   108,    93,    40,   119,     3,    32,    51,     8,     7,
      32,     4,    33,    16,    52,    53,    14,    28,    32,    21,
      28,    49,     3,     0,    27,    42,     7,    26,    22,    50,
      37,    28,    28,    14,     4,    43,    42,    43,    28,    28,
      33,    49,    45,    46,    43,    37,   161,    61,    61,    28,
      49,    62,    16,   160,    62,    53,    54,    50,   226,    62,
      62,    47,    62,    27,    62,    64,    62,    64,   133,    48,
      98,    10,    53,    54,    64,     4,   120,     4,    17,    28,
     116,    45,    46,    38,   115,    47,    25,    38,   203,    10,
     118,   117,   183,   115,   125,   202,    17,   134,     5,    48,
     114,     5,     9,    42,    25,     9,    42,    43,   173,   277,
     146,    18,    19,    20,   150,   206,    20,    24,    22,    15,
      24,    42,    62,   137,    38,    42,    43,    43,   156,    42,
      43,    45,    46,    49,    62,   149,    32,    33,    34,    35,
      36,     8,    38,    39,   182,   185,    62,    56,    57,    58,
      46,    56,    57,    58,    50,   291,   192,    28,   176,    55,
     225,   197,    62,    59,    60,    61,    62,    63,   208,   209,
     210,   199,     5,    33,    34,    62,     9,    42,    43,    62,
     316,    62,   196,    33,    34,    35,    36,    20,    33,    34,
      62,    24,    62,   207,    33,    34,    35,    36,   236,    62,
      62,     0,     1,    62,    62,    62,     5,     6,    62,    62,
       9,    62,    11,    62,    13,    62,    15,    22,    62,    18,
      19,    20,    62,    22,    23,    24,    33,    34,    35,    36,
     244,   244,    62,    32,    33,    34,    35,    36,    62,    38,
      39,    21,    41,    37,    48,    44,   286,    46,    37,    42,
      62,    50,    33,    34,    35,    36,    55,    48,    42,    62,
      59,    60,    61,    48,    63,    62,    62,   281,   281,    42,
      62,   317,    42,    32,    33,    34,    35,    36,    33,    38,
      39,    49,   322,    43,     3,    42,    42,   128,     7,    43,
     227,    50,   130,    12,   314,    14,    15,    16,   312,   312,
      59,    60,    61,    62,    63,   220,   297,   316,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,   332,    38,
      39,   304,   304,   337,   338,   338,    45,    46,    15,    48,
     291,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    32,    33,    34,    35,    36,
     166,    38,    39,   176,   321,   137,    32,   337,   184,    46,
     294,    15,   171,    50,   133,    -1,    -1,    -1,    55,    -1,
      -1,    -1,    59,    60,    61,    -1,    63,    64,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    15,    -1,    -1,    50,    -1,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    59,    60,    61,    62,    63,
      32,    33,    34,    35,    36,    -1,    38,    39,    -1,    -1,
      -1,    -1,    -1,    -1,    46,    15,    -1,    -1,    50,    -1,
      -1,    -1,    -1,    55,    -1,    -1,    -1,    59,    60,    61,
      62,    63,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    46,    15,    -1,    -1,
      50,    -1,    -1,    -1,    -1,    55,    -1,    -1,    -1,    59,
      60,    61,    62,    63,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    -1,    46,    15,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    55,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    32,    33,    34,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      46,    15,    -1,    -1,    50,    -1,    -1,    -1,    -1,    55,
      -1,    -1,    -1,    59,    60,    61,    -1,    63,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    12,    -1,    -1,    50,    16,    -1,    -1,
      -1,    55,    -1,    -1,    -1,    59,    60,    61,    27,    63,
      29,    30,    31,    -1,    -1,    -1,    -1,    -1,    -1,    12,
      -1,    -1,    -1,    16,    -1,    -1,    45,    46,    -1,    48,
      -1,    12,    51,    52,    27,    16,    29,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    27,    -1,    29,    30,
      31,    -1,    45,    46,    -1,    48,    -1,    -1,    51,    52,
      -1,    -1,    -1,    -1,    45,    46,    -1,    -1,    -1,    -1,
      51,    52,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      50,    -1,    -1,    -1,    -1,    -1,    56,    57,    58,    59,
      60,    61,    -1,    63,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,    56,    57,
      58,    59,    60,    61,    -1,    63,    32,    33,    34,    35,
      36,    -1,    38,    39,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    50,    59,    60,    61,    62,    63,    -1,    -1,
      -1,    59,    60,    61,    62,    63,    32,    33,    34,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    59,    60,    61,    -1,    63
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    66,    67,     0,    68,     1,     5,     6,     9,    11,
      13,    15,    18,    19,    20,    22,    23,    24,    32,    33,
      34,    35,    36,    38,    39,    41,    44,    46,    50,    55,
      59,    60,    61,    63,    69,    71,    73,    74,    86,    88,
      89,    90,    96,   102,   113,   114,   119,   121,   123,   124,
     125,   127,   128,   129,   130,   136,   139,   142,    42,    97,
      98,    99,    22,    37,    70,    37,    72,    33,    34,    35,
      36,   144,   145,    33,    35,   100,   101,   133,   136,   140,
      38,    45,    46,    38,    39,   123,     3,     7,    12,    14,
      15,    16,    27,    28,    29,    30,    31,    45,    46,    48,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    62,   116,   117,   118,   119,   120,   121,   122,   126,
     127,   130,   132,    64,   116,   119,   131,    42,    43,    42,
      43,    75,     9,    22,    89,     9,    90,    28,   103,    12,
      16,    27,    29,    30,    31,    45,    46,    51,    52,   115,
     120,     3,     7,    14,    53,    54,   122,   123,    56,    57,
      58,   126,   130,   130,    47,    42,    43,   113,   144,     4,
       4,    47,    81,     4,    80,    42,    43,    38,    38,    21,
       8,   117,   128,    28,    43,    49,    62,   119,    12,    29,
      30,    31,    46,    48,    51,    52,   118,   120,   121,   122,
     123,   125,    58,   126,    62,    62,    28,   118,    26,    43,
      49,    64,    70,    72,    33,    34,    36,    91,    93,   134,
     135,   137,   138,   141,   142,    22,   144,   145,   114,    48,
       8,   121,   119,   121,    21,   123,   128,   125,    33,    34,
      35,    36,   143,    98,    48,    81,    37,    37,   143,    76,
     144,    42,   101,    62,    62,    62,   117,   131,   116,    62,
      62,    62,   119,    62,    62,    62,    62,    62,    62,    62,
     116,   116,   116,    42,    43,    94,    94,   144,    81,    80,
     104,   105,   113,    78,    48,    82,    49,    62,    62,    64,
      64,    92,    33,    50,     4,    95,    81,    77,    42,    48,
     113,    42,    83,    84,    85,    42,   116,    93,    33,   134,
      79,    82,   106,   107,    49,    86,    87,    88,    62,    42,
      42,   113,    10,    17,    25,    42,   108,   109,    84,    91,
     107,   116,   110,    42,   111,   112,   113,    43,    48,   112,
     113
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 101 "qc.y"
    { srcstate(); }
    break;

  case 5:
#line 107 "qc.y"
    { import(); newdecl(); }
    break;

  case 6:
#line 109 "qc.y"
    { include(); newdecl(); }
    break;

  case 7:
#line 111 "qc.y"
    { newdecl(); }
    break;

  case 8:
#line 113 "qc.y"
    { newdecl(); }
    break;

  case 9:
#line 115 "qc.y"
    { newrule(); }
    break;

  case 10:
#line 117 "qc.y"
    { newrule(); }
    break;

  case 12:
#line 126 "qc.y"
    { yyerrok; srcstate(); newrule(); newdecl(); }
    break;

  case 15:
#line 134 "qc.y"
    { add_import(yyvsp[0].sval, NULL); }
    break;

  case 16:
#line 136 "qc.y"
    { add_import(yyvsp[-2].sval, strdup(yyvsp[0].sval)); }
    break;

  case 19:
#line 144 "qc.y"
    { add_import(yyvsp[0].sval, NULL); }
    break;

  case 20:
#line 146 "qc.y"
    { add_import(yyvsp[-2].sval, strdup(yyvsp[0].sval)); }
    break;

  case 21:
#line 150 "qc.y"
    { priority(yyvsp[0].zval); mpz_clear(yyvsp[0].zval); }
    break;

  case 22:
#line 152 "qc.y"
    { priority(yyvsp[0].zval); mpz_clear(yyvsp[0].zval); }
    break;

  case 23:
#line 154 "qc.y"
    { mpz_neg(yyvsp[0].zval,yyvsp[0].zval);
				  priority(yyvsp[0].zval); mpz_clear(yyvsp[0].zval); }
    break;

  case 24:
#line 159 "qc.y"
    { type = 0; }
    break;

  case 26:
#line 162 "qc.y"
    { if (!(symtb[yyvsp[-2].ival].flags&DCL)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else
				    astype(yyvsp[-2].ival, yyvsp[-1].ival, flags); }
    break;

  case 27:
#line 168 "qc.y"
    { if (!(symtb[yyvsp[-2].ival].flags&DCL)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else
				    astype(yyvsp[-2].ival, yyvsp[-1].ival, flags); }
    break;

  case 28:
#line 174 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags);
				  sflags = flags; fno_min = symtbsz; }
    break;

  case 29:
#line 177 "qc.y"
    { /* check for enumeration type */
				  int enumtype = 1, i;
				  fno_max = symtbsz-1;
				  for (i = fno_min; i <= fno_max; i++)
				    if (!(symtb[i].flags & CST) ||
					symtb[i].argc > 0) {
				      enumtype = 0; break;
				    }
				  if (enumtype) {
				    symtb[type].fno_min = fno_min;
				    symtb[type].fno_max = fno_max;
				  }
				}
    break;

  case 30:
#line 191 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags);
				  sflags = flags; fno_min = symtbsz; }
    break;

  case 31:
#line 194 "qc.y"
    { int enumtype = 1, i;
				  fno_max = symtbsz-1;
				  for (i = fno_min; i <= fno_max; i++)
				    if (!(symtb[i].flags & CST) ||
					symtb[i].argc > 0) {
				      enumtype = 0; break;
				    }
				  if (enumtype) {
				    symtb[type].fno_min = fno_min;
				    symtb[type].fno_max = fno_max;
				  }
				}
    break;

  case 32:
#line 207 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags|EXT);
				  sflags = flags; }
    break;

  case 34:
#line 211 "qc.y"
    { type = dcltype(yyvsp[-1].ival, yyvsp[0].ival, flags|EXT);
				  sflags = flags; }
    break;

  case 36:
#line 217 "qc.y"
    { yyval.ival = 0; }
    break;

  case 37:
#line 219 "qc.y"
    { yyval.ival = yyvsp[0].ival; }
    break;

  case 38:
#line 223 "qc.y"
    { yyval.ival = 0; }
    break;

  case 39:
#line 225 "qc.y"
    { yyval.ival = checktype(yyvsp[0].ival); }
    break;

  case 44:
#line 236 "qc.y"
    { flags = sflags; }
    break;

  case 51:
#line 250 "qc.y"
    { flags = PRIV; }
    break;

  case 52:
#line 252 "qc.y"
    { flags = 0; }
    break;

  case 55:
#line 260 "qc.y"
    { flags |= CST; }
    break;

  case 56:
#line 262 "qc.y"
    { flags |= SPEC; }
    break;

  case 57:
#line 264 "qc.y"
    { flags |= EXT; }
    break;

  case 58:
#line 266 "qc.y"
    { flags |= VSYM; }
    break;

  case 60:
#line 270 "qc.y"
    { argv = 0; }
    break;

  case 62:
#line 274 "qc.y"
    { if ((flags & VSYM) && (yyvsp[0].ival || type) ||
				      (flags & VSYM) && (flags & (EXT|SPEC)) ||
				      (flags & CST) && (flags & EXT) ||
				      !(flags & VSYM) &&
				      isupper(strsp[symtb[yyvsp[-1].ival].pname]) ||
				      (symtb[yyvsp[-1].ival].flags & DCL) &&
				      (symtb[yyvsp[-1].ival].flags & VSYM) !=
				      (flags & VSYM)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else if (flags & VSYM)
				    dclfvar(yyvsp[-1].ival, flags);
				  else
				    dclfun(yyvsp[-1].ival, type, yyvsp[0].ival, argv, flags); }
    break;

  case 63:
#line 289 "qc.y"
    { if (!(symtb[yyvsp[-2].ival].flags&DCL) ||
				      (flags & VSYM) && (yyvsp[-1].ival || type) ||
				      (flags & VSYM) && (flags & (EXT|SPEC)) ||
				      (flags & CST) && (flags & EXT) ||
				      !(flags & VSYM) &&
				      isupper(strsp[symtb[yyvsp[-2].ival].pname]) ||
				      (symtb[yyvsp[-2].ival].flags & DCL) &&
				      (symtb[yyvsp[-2].ival].flags & VSYM) !=
				      (flags & VSYM) ||
				      type ||
				      yyvsp[0].ival && symtb[yyvsp[0].ival].modno == modno &&
				      (symtb[yyvsp[0].ival].flags&DCL)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else if (flags & VSYM)
				    asfvar(yyvsp[-2].ival, yyvsp[0].ival, flags);
				  else
				    asfun(yyvsp[-2].ival, yyvsp[0].ival, yyvsp[-1].ival, argv, flags); }
    break;

  case 64:
#line 310 "qc.y"
    { yyval.ival = 0; }
    break;

  case 65:
#line 312 "qc.y"
    { if (flags & SPEC)
				    if (yyvsp[-1].ival < sizeof(unsigned long)*8)
				      argv |= 1<<yyvsp[-1].ival;
				    else {
				      yyerror(qcmsg[DCL_ERROR]);
				      YYERROR;
				    }
				  yyval.ival = yyvsp[-1].ival+1; }
    break;

  case 66:
#line 321 "qc.y"
    { if (!(flags & SPEC)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  }
				  yyval.ival = yyvsp[-2].ival+1; }
    break;

  case 67:
#line 329 "qc.y"
    { yyval.ival = 0; }
    break;

  case 68:
#line 331 "qc.y"
    { yyval.ival = yyvsp[0].ival; }
    break;

  case 73:
#line 342 "qc.y"
    { debug_info(); init_def(); }
    break;

  case 74:
#line 344 "qc.y"
    { definition(yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 77:
#line 352 "qc.y"
    { init_def();
				  if (!(symtb[yyvsp[0].ival].flags & VSYM))
				    yyerror(qcmsg[INVALID_DEF]);
				  else {
				    symtb[yyvsp[0].ival].flags |= DCL;
				    debug_info();
				    definition(funexpr(yyvsp[0].ival), NULL);
				  }
				}
    break;

  case 78:
#line 364 "qc.y"
    { debug_info(); left_hand_side(yyvsp[0].xval); mark(); }
    break;

  case 80:
#line 368 "qc.y"
    { fix_debug_info(); start_qualifiers(); }
    break;

  case 81:
#line 370 "qc.y"
    { qualifiers(); right_hand_side(yyvsp[-2].xval); }
    break;

  case 82:
#line 372 "qc.y"
    { fix_debug_info(); start_qualifiers(); }
    break;

  case 83:
#line 374 "qc.y"
    { qualifiers(); right_hand_side(yyvsp[-2].xval); }
    break;

  case 85:
#line 379 "qc.y"
    { add_qualifier(yyvsp[0].xval); }
    break;

  case 87:
#line 384 "qc.y"
    { yyval.xval = yyvsp[0].xval; }
    break;

  case 88:
#line 386 "qc.y"
    { yyval.xval = NULL; }
    break;

  case 89:
#line 390 "qc.y"
    { start_where_clauses(); }
    break;

  case 90:
#line 392 "qc.y"
    { end_where_clauses(); }
    break;

  case 93:
#line 400 "qc.y"
    { add_where_clause(yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 95:
#line 405 "qc.y"
    { yyval.xval = binexpr(SEQOP, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 97:
#line 410 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 98:
#line 413 "qc.y"
    { yyval.ival = LEOP; }
    break;

  case 99:
#line 414 "qc.y"
    { yyval.ival = GROP; }
    break;

  case 100:
#line 415 "qc.y"
    { yyval.ival = LEQOP; }
    break;

  case 101:
#line 416 "qc.y"
    { yyval.ival = GEQOP; }
    break;

  case 102:
#line 417 "qc.y"
    { yyval.ival = NEQOP; }
    break;

  case 103:
#line 418 "qc.y"
    { yyval.ival = INOP; }
    break;

  case 105:
#line 423 "qc.y"
    { yyval.xval = binexpr(SEQOP, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 107:
#line 428 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 108:
#line 431 "qc.y"
    { yyval.ival = LEOP; }
    break;

  case 109:
#line 432 "qc.y"
    { yyval.ival = GROP; }
    break;

  case 110:
#line 433 "qc.y"
    { yyval.ival = EQOP; }
    break;

  case 111:
#line 434 "qc.y"
    { yyval.ival = LEQOP; }
    break;

  case 112:
#line 435 "qc.y"
    { yyval.ival = GEQOP; }
    break;

  case 113:
#line 436 "qc.y"
    { yyval.ival = NEQOP; }
    break;

  case 114:
#line 437 "qc.y"
    { yyval.ival = INOP; }
    break;

  case 116:
#line 442 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 117:
#line 444 "qc.y"
    { yyval.xval = binexpr(MINOP, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 118:
#line 447 "qc.y"
    { yyval.ival = ADDOP; }
    break;

  case 119:
#line 448 "qc.y"
    { yyval.ival = CATOP; }
    break;

  case 120:
#line 449 "qc.y"
    { yyval.ival = OROP; }
    break;

  case 121:
#line 450 "qc.y"
    { yyval.ival = ORELSEOP; }
    break;

  case 123:
#line 455 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 124:
#line 458 "qc.y"
    { yyval.ival = MULOP; }
    break;

  case 125:
#line 459 "qc.y"
    { yyval.ival = FDIVOP; }
    break;

  case 126:
#line 460 "qc.y"
    { yyval.ival = DIVOP; }
    break;

  case 127:
#line 461 "qc.y"
    { yyval.ival = MODOP; }
    break;

  case 128:
#line 462 "qc.y"
    { yyval.ival = ANDOP; }
    break;

  case 129:
#line 463 "qc.y"
    { yyval.ival = ANDTHENOP; }
    break;

  case 131:
#line 469 "qc.y"
    { mpz_neg(yyvsp[0].zval, yyvsp[0].zval); yyval.xval = intexpr(yyvsp[0].zval); }
    break;

  case 132:
#line 470 "qc.y"
    { yyval.xval = floatexpr(-yyvsp[0].fval); }
    break;

  case 133:
#line 471 "qc.y"
    { yyval.xval = unexpr(UMINOP, yyvsp[0].xval); }
    break;

  case 134:
#line 472 "qc.y"
    { yyval.xval = unexpr(yyvsp[-1].ival, yyvsp[0].xval); }
    break;

  case 135:
#line 475 "qc.y"
    { yyval.ival = HASHOP; }
    break;

  case 136:
#line 476 "qc.y"
    { yyval.ival = NOTOP; }
    break;

  case 138:
#line 481 "qc.y"
    { yyval.xval = binexpr(yyvsp[-1].ival, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 139:
#line 484 "qc.y"
    { yyval.ival = POWOP; }
    break;

  case 140:
#line 485 "qc.y"
    { yyval.ival = IDXOP; }
    break;

  case 142:
#line 490 "qc.y"
    { yyval.xval = binexpr(COMPOP, yyvsp[-2].xval, yyvsp[0].xval); }
    break;

  case 144:
#line 495 "qc.y"
    { yyval.xval = appexpr(yyvsp[-1].xval, yyvsp[0].xval); }
    break;

  case 145:
#line 498 "qc.y"
    { yyval.ival = QUOTEOP; }
    break;

  case 146:
#line 499 "qc.y"
    { yyval.ival = UNQUOTEOP; }
    break;

  case 147:
#line 500 "qc.y"
    { yyval.ival = FORCEOP; }
    break;

  case 148:
#line 506 "qc.y"
    { yyval.xval = intexpr(yyvsp[0].zval); }
    break;

  case 149:
#line 507 "qc.y"
    { yyval.xval = floatexpr(yyvsp[0].fval); }
    break;

  case 150:
#line 508 "qc.y"
    { yyval.xval = strexpr(yyvsp[0].ival); }
    break;

  case 151:
#line 512 "qc.y"
    { yyval.xval = funexpr(yyvsp[-1].ival); }
    break;

  case 152:
#line 513 "qc.y"
    { yyval.xval = funexpr(yyvsp[0].ival); }
    break;

  case 153:
#line 514 "qc.y"
    { yyval.xval = funexpr(yyvsp[0].ival); }
    break;

  case 154:
#line 515 "qc.y"
    { vartb[yyvsp[0].ival].type = 0;
				  yyval.xval = varexpr(yyvsp[0].ival); }
    break;

  case 155:
#line 517 "qc.y"
    { checktype(yyvsp[0].ival);
		                  vartb[yyvsp[-2].ival].type = yyvsp[0].ival;
				  yyval.xval = varexpr(yyvsp[-2].ival); }
    break;

  case 156:
#line 524 "qc.y"
    { yyval.xval = unexpr(yyvsp[-1].ival, yyvsp[0].xval); }
    break;

  case 157:
#line 529 "qc.y"
    { yyval.xval = appexpr(funexpr(SEQOP), yyvsp[-2].xval); }
    break;

  case 158:
#line 532 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(SEQOP)),
					       yyvsp[-1].xval); }
    break;

  case 159:
#line 537 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 160:
#line 540 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 161:
#line 545 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 162:
#line 548 "qc.y"
    { yyval.xval = appexpr(funexpr(MINOP), yyvsp[-2].xval); }
    break;

  case 163:
#line 551 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 164:
#line 556 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 165:
#line 559 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 166:
#line 564 "qc.y"
    { yyval.xval = appexpr(funexpr(yyvsp[-1].ival), yyvsp[-2].xval); }
    break;

  case 167:
#line 567 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(yyvsp[-2].ival)),
					       yyvsp[-1].xval); }
    break;

  case 168:
#line 572 "qc.y"
    { yyval.xval = appexpr(funexpr(COMPOP), yyvsp[-2].xval); }
    break;

  case 169:
#line 575 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr(COMPOP)),
					       yyvsp[-1].xval); }
    break;

  case 170:
#line 582 "qc.y"
    { yyval.xval = funexpr(VOIDOP); }
    break;

  case 171:
#line 584 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-1].xval, funexpr(VOIDOP)); }
    break;

  case 172:
#line 586 "qc.y"
    { yyval.xval = yyvsp[-1].xval; }
    break;

  case 173:
#line 588 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-3].xval, yyvsp[-1].xval); }
    break;

  case 174:
#line 590 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-3].xval,
				  tupleexpr(addexpr(yyvsp[-1].xvval, funexpr(VOIDOP)))); }
    break;

  case 175:
#line 593 "qc.y"
    { yyval.xval = pairexpr(yyvsp[-5].xval,
				  tupleexpr(addexpr(yyvsp[-3].xvval, yyvsp[-1].xval))); }
    break;

  case 176:
#line 599 "qc.y"
    { yyval.xval = funexpr(NILOP); }
    break;

  case 177:
#line 601 "qc.y"
    { yyval.xval = listexpr(
				  addexpr(yyvsp[-1].xvval, funexpr(NILOP))); }
    break;

  case 178:
#line 604 "qc.y"
    { yyval.xval = listexpr(addexpr(yyvsp[-3].xvval, yyvsp[-1].xval)); }
    break;

  case 179:
#line 606 "qc.y"
    { yyval.xval = appexpr(appexpr(funexpr(ENUMOP),
				  listexpr(addexpr(yyvsp[-3].xvval, funexpr(NILOP)))),
				  yyvsp[-1].xval); }
    break;

  case 180:
#line 612 "qc.y"
    { yyval.xvval = addexpr(exprlist(), yyvsp[0].xval); }
    break;

  case 181:
#line 614 "qc.y"
    { yyval.xvval = addexpr(yyvsp[-2].xvval, yyvsp[0].xval); }
    break;

  case 182:
#line 617 "qc.y"
    { yyval.ival = SEQOP; }
    break;

  case 183:
#line 618 "qc.y"
    { yyval.ival = LEOP; }
    break;

  case 184:
#line 619 "qc.y"
    { yyval.ival = GROP; }
    break;

  case 185:
#line 620 "qc.y"
    { yyval.ival = EQOP; }
    break;

  case 186:
#line 621 "qc.y"
    { yyval.ival = LEQOP; }
    break;

  case 187:
#line 622 "qc.y"
    { yyval.ival = GEQOP; }
    break;

  case 188:
#line 623 "qc.y"
    { yyval.ival = NEQOP; }
    break;

  case 189:
#line 624 "qc.y"
    { yyval.ival = INOP; }
    break;

  case 190:
#line 625 "qc.y"
    { yyval.ival = CATOP; }
    break;

  case 191:
#line 626 "qc.y"
    { yyval.ival = ADDOP; }
    break;

  case 192:
#line 627 "qc.y"
    { yyval.ival = MINOP; }
    break;

  case 193:
#line 628 "qc.y"
    { yyval.ival = OROP; }
    break;

  case 194:
#line 629 "qc.y"
    { yyval.ival = ORELSEOP; }
    break;

  case 195:
#line 630 "qc.y"
    { yyval.ival = MULOP; }
    break;

  case 196:
#line 631 "qc.y"
    { yyval.ival = FDIVOP; }
    break;

  case 197:
#line 632 "qc.y"
    { yyval.ival = DIVOP; }
    break;

  case 198:
#line 633 "qc.y"
    { yyval.ival = MODOP; }
    break;

  case 199:
#line 634 "qc.y"
    { yyval.ival = ANDOP; }
    break;

  case 200:
#line 635 "qc.y"
    { yyval.ival = ANDTHENOP; }
    break;

  case 201:
#line 636 "qc.y"
    { yyval.ival = HASHOP; }
    break;

  case 202:
#line 637 "qc.y"
    { yyval.ival = NOTOP; }
    break;

  case 203:
#line 638 "qc.y"
    { yyval.ival = QUOTEOP; }
    break;

  case 204:
#line 639 "qc.y"
    { yyval.ival = UNQUOTEOP; }
    break;

  case 205:
#line 640 "qc.y"
    { yyval.ival = FORCEOP; }
    break;

  case 206:
#line 641 "qc.y"
    { yyval.ival = POWOP; }
    break;

  case 207:
#line 642 "qc.y"
    { yyval.ival = IDXOP; }
    break;

  case 208:
#line 643 "qc.y"
    { yyval.ival = COMPOP; }
    break;

  case 215:
#line 659 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 216:
#line 661 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 217:
#line 665 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 218:
#line 669 "qc.y"
    { yyval.ival = mkfun(yyvsp[0].sval); }
    break;

  case 219:
#line 673 "qc.y"
    { yyval.ival = mkvar(yyvsp[0].sval); }
    break;

  case 220:
#line 677 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 221:
#line 679 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 222:
#line 683 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 223:
#line 687 "qc.y"
    { yyval.ival = mkfvar(yyvsp[0].sval); }
    break;

  case 224:
#line 691 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;

  case 225:
#line 693 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;

  case 226:
#line 695 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;

  case 227:
#line 697 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;

  case 228:
#line 701 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;

  case 229:
#line 703 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;

  case 230:
#line 707 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;

  case 231:
#line 709 "qc.y"
    { yyval.ival = mktype(yyvsp[0].sval); }
    break;


    }

/* Line 991 of yacc.c.  */
#line 2552 "qc.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__) \
    && !defined __cplusplus
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 712 "qc.y"


extern int      yyleng, yylineno;
extern char     *source;

yyerror(s)
	char           *s;
{
	fprintf(stderr, "Error %s, line %d: %s", source, yylineno, s);
	if (
#ifdef YYBISON
	    strcmp(s, "parse error") == 0
#else
	    strcmp(s, "syntax error") == 0
#endif
	   )
		if (*yytext)
			fprintf(stderr, " at or near symbol `%s'", yytext);
		else
			fprintf(stderr, " at end of file");
	fprintf(stderr, "\n");
	nerrs++;
}

yywarn(s)
	char           *s;
{
	if (wflag) {
		fprintf(stderr, "Warning %s, line %d: %s\n", source,
			yylineno, s);
		nwarns++;
	}
}

fatal(s)
	char           *s;
{
	if (source && *source)
		fprintf(stderr, "%s: %s: %s -- compilation aborted\n",
			self, source, s);
	else
		fprintf(stderr, "%s: %s -- compilation aborted\n",
			self, s);
	if (codefp) {
		fclose(codefp);
		remove(code);
	}
	exit(1);
}

#define no(n) n, n==1?"":"s"

static
statistics()
{
	int fno, k, n, b, bmax, btotal, n_data;
	for (n = bmax = btotal = k = 0; k < hashtbsz; k++)
		if (hashtb[k] != NONE) {
			n++;
			for (b = -1, fno = hashtb[k]; fno != NONE;
			     b++, fno = symtb[fno].next)
				;
			btotal += b;
			if (b+1>bmax)
				bmax = b+1;
		}
	n_data = strspsz+limbspsz*sizeof(mp_limb_t);
	printf("%d ops in %d module%s, ", codespsz, no(modtbsz));
	printf("%d byte%s data, ", no(n_data));
	printf("%d symbol%s,\n", no(symtbsz));
	printf("%d hash key%s out of %d, %d collision%s, max bucket size = %d\n",
	       no(n), hashtbsz, no(btotal), bmax);
	printf("%d state%s, %d transition%s, %d offset%s\n",
	       no(statetbsz), no(transtbsz), no(roffstbsz));
}

static void *
gmp_allocate (size)
     size_t size;
{
  void *ret;

  ret = malloc (size);
  if (ret == 0) fatal(qcmsg[MEM_OVF]);
  return ret;
}

static void *
gmp_reallocate (oldptr, old_size, new_size)
     void *oldptr;
     size_t old_size;
     size_t new_size;
{
  void *ret;

  ret = realloc (oldptr, new_size);
  if (ret == 0) fatal(qcmsg[MEM_OVF]);
  return ret;
}

static void
gmp_free (blk_ptr, blk_size)
     void *blk_ptr;
     size_t blk_size;
{
  free (blk_ptr);
}

RETSIGTYPE
break_handler()
/* handle SIGINT and SIGTERM */
{
  /* Since many system functions are unsave to call in a signal
     handler, we simply set a flag here; the corresponding actions
     in response to SIGINT (remove code file, close list file,
     terminate program) will be carried out later in a save
     context. */
  int_sig = 1;
  SIGHANDLER_RETURN(0);
}

checkint()
/* check for pending int_sig */
{
  if (int_sig) fatal("interrupt");
}

newrule()
/* reinitialize for the next rule */
{
  clear(); checkint();
}

newdecl()
/* reinitialize for the next declaration */
{
  flags = PRIV; argv = 0; checkint();
}

priority(z)
     mpz_t z;
/* set a new priority level */
{
  if (my_mpz_fits_slong_p(z))
    prio = mpz_get_si(z);
  else
    yyerror(qcmsg[INVALID_PRIO]);
}

/* qualifier table */

int qual_size, qual_alloc, clause_size, clause_alloc;
static QUAL *qual;
static CLAUSE *clause;

static void start_qualifiers(void)
{
  qual_size = clause_size = 0;
}

static void qualifiers(void)
{
  int i;
  for (i = qual_size-1; i >= 0; i--)
    if (qual[i].x)
      qualifier(qual[i].x);
    else {
      int j;
      for (j = qual[i].start; j < qual[i].end; j++)
	where_clause(clause[j].l, clause[j].r);
    }
}

static void add_qualifier(EXPR *x)
{
  if (!x) return;
  if (qual_size >= qual_alloc)
    if ((qual = arealloc(qual, qual_alloc, 10, sizeof(QUAL))))
      qual_alloc += 10;
    else
      fatal("memory overflow");
  qual[qual_size++].x = x;
}

static void start_where_clauses(void)
{
  if (qual_size >= qual_alloc)
    if ((qual = arealloc(qual, qual_alloc, 10, sizeof(QUAL))))
      qual_alloc += 10;
    else
      fatal("memory overflow");
  qual[qual_size].x = NULL;
  qual[qual_size].start = clause_size;
}

static void end_where_clauses(void)
{
  qual[qual_size++].end = clause_size;
}

static void add_where_clause(EXPR *l, EXPR *r)
{
  if (clause_size >= clause_alloc)
    if ((clause = arealloc(clause, clause_alloc, 10, sizeof(CLAUSE))))
      clause_alloc += 10;
    else
      fatal("memory overflow");
  clause[clause_size].l = l;
  clause[clause_size].r = r;
  clause_size++;
}

/* expression lists */

static xvect_t *exprlist(void)
{
  xvect_t *v = (xvect_t*)malloc(sizeof(xvect_t));
  if (!v) fatal("memory overflow");
  v->a = v->n = 0;
  v->xv = NULL;
  return v;
}

static xvect_t *addexpr(xvect_t *v, EXPR *x)
{
  if (v->n >= v->a) {
    v->a += 10;
    if (v->xv)
      v->xv = realloc(v->xv, v->a*sizeof(EXPR*));
    else
      v->xv = malloc(v->a*sizeof(EXPR*));
    if (!v->xv) fatal("memory overflow");
  }
  v->xv[v->n++] = x;
  return v;
}

static EXPR *tupleexpr(xvect_t *v)
{
  EXPR *x;
  int n = v->n;
  if (n <= 0) fatal("internal compiler error");
  x = v->xv[--n];
  while (n > 0)
    x = pairexpr(v->xv[--n], x);
  free(v->xv);
  free(v);
  return x;
}

static EXPR *listexpr(xvect_t *v)
{
  EXPR *x;
  int n = v->n;
  if (n <= 0) fatal("internal compiler error");
  x = v->xv[--n];
  while (n > 0)
    x = consexpr(v->xv[--n], x);
  free(v->xv);
  free(v);
  return x;
}

static struct option longopts[] = QC_OPTS;
static struct option all_longopts[] = Q_OPTS;

static int
getintarg(char *s, int *i)
{
  char *t = s;
  while (isspace(*t)) t++;
  s = t;
  while (isdigit(*t)) t++;
  if (t == s) return 0;
  while (isspace(*t)) t++;
  if (*t) return 0;
  *i = atoi(s);
  return 1;
}

static void
parse_opts(argc, argv, pass)
     int argc;
     char **argv;
     int pass; /* 0 denotes source, 1 command line pass */
{
  int c, longind;
  optind = 0;
  while ((c = getopt_long(argc, argv,
			  pass?QC_OPTS1:Q_OPTS1,
			  pass?longopts:all_longopts,
			  &longind)) != EOF)
    switch (c) {
    case QC_NO_PRELUDE:
      prelude = NULL;
      break;
    case QC_PRELUDE:
      prelude = optarg?optarg:prelude;
      break;
    case 'h':
      hflag = 1;
      break;
    case 'l':
      list = optarg?optarg:list;
      break;
    case 'n':
      nflag = 1;
      break;
    case 'o':
      code = optarg?optarg:code;
      break;
    case 'p':
      if (optarg) {
	change_qpath(optarg);
	if (!qpath) fatal("memory overflow");
      }
      break;
    case 't': {
      int sz;
      if (optarg && getintarg(optarg, &sz) && sz > 0)
	hashtbsz = sz;
      else {
	char msg[MAXSTRLEN];
	sprintf(msg, "invalid size `%s'", optarg?optarg:"");
	fatal(msg);
      }
      break;
    }
    case 'v':
      vflag = 1;
      break;
    case 'w':
      wflag = 1;
      break;
    case 'V':
      Vflag = 1;
      break;
    /* interpreter options (ignored): */
    case Q_GNUCLIENT:
    case Q_DEBUG_OPTIONS:
    case Q_BREAK:
    case Q_PROMPT:
    case Q_DEC:
    case Q_HEX:
    case Q_OCT:
    case Q_STD:
    case Q_SCI:
    case Q_FIX:
    case Q_HISTFILE:
    case Q_HISTSIZE:
    case Q_INITRC:
    case Q_NO_INITRC:
    case Q_EXITRC:
    case Q_NO_EXITRC:
    case Q_NO_EDITING:
    case Q_GC_MSGS:
    case Q_GC:
    case Q_STACKSIZE:
    case Q_MEMSIZE:
    case 'd':
    case 'e':
    case 'i':
    case 'q':
    case 'c':
    case 's':
      break;
    default:
      exit(1);
    }
}

static int sargc;
static char **sargv;

static void
get_source_opts(fp)
     FILE *fp;
{
  char s[MAXSTRLEN];
  int i;
  bool first = 1;

  sargc = 1;
  if (!(sargv = aalloc(1, sizeof(char*)))) fatal(qcmsg[MEM_OVF]);
  *sargv = strdup(self);
  while (!feof(fp) && !ferror(fp) &&
	 fgets(s, MAXSTRLEN, fp)) {
    int l = strlen(s);
    if (l > 0 && s[l-1] == '\n') s[l-1] = '\0', l--;
    if (l == 0) {
      first = 0;
      continue;
    } else if (strncmp(s, "#!", 2) == 0)
      if (!first && isspace(s[2])) {
	char *p = s+3;
	while (isspace(*p)) p++;
	sargv = arealloc(sargv, sargc, 1, sizeof(char*));
	sargv[sargc++] = strdup(p);
      } else {
	first = 0;
	continue;
      }
    else
      break;
  }
  sargv = arealloc(sargv, sargc, 1, sizeof(char*));
  sargv[sargc] = NULL;
}

main(argc, argv)
	int             argc;
	char          **argv;
{
	int c, longind;
	char *s;

#ifdef _WIN32
	InstallSignalHandler();
#endif

	/* get program name: */
	self = argv[0];

	/* get environment settings: */
	if ((s = getenv("QPATH")) != NULL)
	  init_qpath(s);
	else
	  init_qpath(QPATH);
	if (!qpath) fatal("memory overflow");

	/* scan command line to obtain the first source file name: */
	opterr = 0;
	while ((c = getopt_long(argc, argv, Q_OPTS1,
				longopts, &longind)) != EOF)
	  ;
	opterr = 1;

	/* get options from the main script: */
	if (argc-optind >= 1) {
	  char fname[MAXSTRLEN];
	  FILE *fp;
	  if (chkfile(searchlib(fname, argv[optind])) &&
	      (fp = fopen(fname, "r")) != NULL) {
	    get_source_opts(fp);
	    fclose(fp);
	    parse_opts(sargc, sargv, 0);
	  }
	}

	/* get command line options: */
	parse_opts(argc, argv, 1);
	argc -= optind, argv += optind;

	if (Vflag) {
		printf(signon, version, sysinfo, year);
		printf(copying);
		printf(helpmsg, self);
		exit(0);
	}
	if (hflag) {
		printf(usage, self);
		sprintf(opts, QC_OPTMSG, QPATH, HASHTBSZ);
		fputs(opts, stdout);
		exit(0);
	}

	/* install break and term handlers: */
	sigint(break_handler);
	sigterm(break_handler);
	sighup(break_handler);

	/* install gmp memory handlers */
	mp_set_memory_functions(gmp_allocate, gmp_reallocate, gmp_free);

	/* set code file id: */
	sprintf(outid, OUTID, version, sysinfo);

	/* compile: */
	if (*list) {
	  FILE *fp;
	  if (!(fp = fopen(list, "w"))) {
	    fprintf(stderr, "%s: error creating %s\n",
		    self, list);
	    exit(1);
	  } else {
	    fclose(fp);
	    freopen(list, "w", stderr);
	  }
	}
	if (!(codefp = fopen(code, "wb"))) {
	  fprintf(stderr, "%s: error creating %s\n",
		  self, code);
	  exit(1);
	}
	mainno = -1;
	write_header();
	inittables();
	if (!initlex(argc, argv))
	  /* empty source; skip parse */
	  goto generate;
	if (yyparse() == 0 && nerrs == 0) {
	generate:
	  if (!nflag) {
	    /* generate code: */
	    write_strsp();
	    write_limbsp();
	    write_hashtb();
	    write_symtb();
	    write_TA();
	    write_matchtb();
	    write_inittb();
	    write_modtb();
	    fix_header();
	  }
	  checkint();
	  if (nflag) {
	    fclose(codefp);
	    remove(code);
	  } else
	    fclose(codefp);
	  if (list && !nwarns) {
	    fclose(stderr);
	    remove(list);
	  }
	  if (vflag)
	    if (nflag)
	      printf("(no code generated)\n");
	    else
	      statistics();
	  exit(0);
	} else {
	  checkint();
	  fclose(codefp);
	  remove(code);
	  if (vflag)
	    putchar('\n');
	  exit(1);
	}
}

